/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2023 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

import type { Player, PlayerList, Server } from "@type/data.ts";
import { PlayerListSchema, PlayerSchema, ServerSchema } from "@type/data.ts";
import { fetchWithToken, tokenStore } from "./repo.ts";
import { derived, get } from "svelte/store";
import { TeamSchema, type Team } from "@components/types/team.ts";

export class DataRepo {
    constructor(private token: string) {}

    public async getServer(): Promise<Server> {
        return await fetchWithToken(this.token, "/data/server")
            .then((value) => value.json())
            .then(ServerSchema.parse);
    }

    public async getMe(): Promise<Player> {
        return await fetchWithToken(this.token, "/data/me")
            .then((value) => value.json())
            .then(PlayerSchema.parse);
    }

    public async queryPlayers(
        name: string | undefined,
        uuid: string | undefined,
        team: number[] | undefined,
        limit: number | undefined,
        page: number | undefined,
        includePerms: boolean | undefined,
        includeId: boolean | undefined
    ): Promise<PlayerList> {
        let query = new URLSearchParams();

        if (name) query.append("name", name);
        if (uuid) query.append("uuid", uuid);
        if (team) team.forEach((t) => query.append("team", t.toString()));
        if (limit) query.append("limit", limit.toString());
        if (page) query.append("page", page.toString());
        if (includePerms !== undefined) query.append("includePerms", includePerms.toString());
        if (includeId !== undefined) query.append("includeId", includeId.toString());

        return await fetchWithToken(this.token, "/data/admin/users?" + query.toString())
            .then((value) => value.json())
            .then(PlayerListSchema.parse);
    }

    public async getTeams(): Promise<Team[]> {
        return await fetchWithToken(get(tokenStore), "/data/admin/teams")
            .then((value) => value.json())
            .then(TeamSchema.array().parse);
    }
}

export const dataRepo = derived(tokenStore, ($token) => new DataRepo($token));
